""" ibody.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from event import *
import worldi, worldi__skel, wtime
from vbody import vbody

class ibody(vbody,worldi__skel.ibody):
    def __init__(self, **kw):
        apply(vbody.__init__,(self,),kw)
        self.input_list=[]
        self.time=wtime.world_time()
        self.output_list=[]
    def getId(self):
        return self.id
    def send(self, e_str):
        mind_output=eval(e_str)
        #if len(mind_output):
        #    print ">",e_str
        if len(mind_output)==1 and mind_output[0].command=='look':
            le=self.get_look_event(mind_output[0].what)
            self.input_list=le+self.input_list
        else:
            self.output_list=self.output_list+mind_output
    def receive(self):
        res=`(self.time,self.input_list)`
        #if len(self.input_list):
        #    print "<",`self.input_list`
        self.input_list=[]
        return res
    def run_step(self, time, input):
        self.time=time
        self.input_list=self.input_list+input
        events_replace_id_with_thing(self,self.output_list)
        res=self.output_list
        self.output_list=[]
        #print "bodyi.run_step:",time,input
        return res

