""" vbody.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

import const
from thing import thing
from event import *

class vbody(thing):
    def get_look_event(self, id):
        t=self.find_thing_by_id(id)
        if t.id!=id:
            return [event("illegal",what=id,what_desc="id")]
        return t.look_event(event("look"))
    def find_thing_by_id(self, id):
        t=self.w.id_dict.get(id)
        if not t:
            #print `self`,id,"is destroyed missing!"
            t=self.w.id_dict['illegal']
            #import time
            #time.sleep(10)
        return t
    def send_events(self,time,input):
        if not hasattr(self.mind,"receive_events"):
            return self.mind.run_step(time,input)
        input2=events_replace_thing_with_id(self,input)
        while 1:
            if const.use_string_events:
                mind_output=eval(self.mind.receive_events(time,`input2`))
            else:
                mind_output=self.mind.receive_events(time,input2)
            if len(mind_output)==1 and mind_output[0].command=='look':
                id=mind_output[0].what
                le=self.get_look_event(id)
                input2=le+input2
            else: break
        events_replace_id_with_thing(self,mind_output)
        return mind_output
