""" god_body.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from vbody import vbody

class god_body(vbody):
    def __init__(self, **kw):
        apply(vbody.__init__,(self,),kw)
        self.mind=None
    #event handling: 
    #pass all events unchanged
    #this is actually not used (runs directly mind.run_step())
    def move_event(self,e): return [e]
    def change_event(self,e): return [e]
    #def look_event(self,e): return [e]
    def undefined_event(self,e): return [e]
    def run_step(self,time,input):
        if self.mind:
            return self.mind.run_step(time,input)
