""" misc.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from types import *
import types

def flatten1(l):
    res=[]
    for i in l:
        if type(i)==ListType:
            for j in i: res.append(j)
        else: res.append(i)
    return res

def get_derivation_string(cl):
    try:
        base_class=cl.__bases__[0]
        return get_derivation_string(base_class)+"."+cl.__name__
    except IndexError:
        return cl.__name__

def get_kw(kw, name, default=None):
    if kw.has_key(name): return kw[name]
    if kw.has_key("copy"):
        copy=kw["copy"]
        if hasattr(copy,name): return getattr(copy,name)
    return default

def set_kw(self, kw, name, default=None):
    self.attributes.append(name)
    value=get_kw(kw,name,default)
    setattr(self,name,value)


thing_class_dict={}
def get_thing_class(what):
    global thing_class_dict_list
    try:
        return thing_class_dict[what]
    except KeyError:
        try:
            exec("from "+what+" import "+what)
            t=eval(what)
            thing_class_dict[what]=t
            return t
        except ImportError:
            return get_thing_class("thing")
