""" prob.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

import const,wtime,whrandom

steps_per_day=wtime.days(1)/const.stepseconds

#body.py, age.py, defworld.py:
birth_probability=0.1
#fertility_age=wtime.years(18)
fertility_age=wtime.days(10)

#house.py
fire_probability=0.05

def does_it_happen(prob):
    return whrandom.random()<prob/steps_per_day

def die(age):
    if age<fertility_age: prob=birth_probability*0.1
    elif age<fertility_age*2: prob=birth_probability*0.5
    elif age<fertility_age*3: prob=birth_probability
    elif age<fertility_age*5: prob=birth_probability*2
    else: prob=birth_probability*10
    return does_it_happen(prob)

def birth(age):
    if age<fertility_age: return 0
    return does_it_happen(birth_probability)
